<?php

namespace App|C\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfBagAllowance ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfBagAllowance
 * @subpackage Arrays
 */
class ArrayOfBagAllowance extends AbstractStructArrayBase
{
    /**
     * The BagAllowance
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\BagAllowance[]
     */
    public $BagAllowance;
    /**
     * Constructor method for ArrayOfBagAllowance
     * @uses ArrayOfBagAllowance::setBagAllowance()
     * @param \App|C\StructType\BagAllowance[] $bagAllowance
     */
    public function __construct(array $bagAllowance = array())
    {
        $this
            ->setBagAllowance($bagAllowance);
    }
    /**
     * Get BagAllowance value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\BagAllowance[]|null
     */
    public function getBagAllowance()
    {
        return isset($this->BagAllowance) ? $this->BagAllowance : null;
    }
    /**
     * This method is responsible for validating the values passed to the setBagAllowance method
     * This method is willingly generated in order to preserve the one-line inline validation within the setBagAllowance method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateBagAllowanceForArrayConstraintsFromSetBagAllowance(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfBagAllowanceBagAllowanceItem) {
            // validation for constraint: itemType
            if (!$arrayOfBagAllowanceBagAllowanceItem instanceof \App|C\StructType\BagAllowance) {
                $invalidValues[] = is_object($arrayOfBagAllowanceBagAllowanceItem) ? get_class($arrayOfBagAllowanceBagAllowanceItem) : sprintf('%s(%s)', gettype($arrayOfBagAllowanceBagAllowanceItem), var_export($arrayOfBagAllowanceBagAllowanceItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The BagAllowance property can only contain items of type \App|C\StructType\BagAllowance, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set BagAllowance value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\BagAllowance[] $bagAllowance
     * @return \App|C\ArrayType\ArrayOfBagAllowance
     */
    public function setBagAllowance(array $bagAllowance = array())
    {
        // validation for constraint: array
        if ('' !== ($bagAllowanceArrayErrorMessage = self::validateBagAllowanceForArrayConstraintsFromSetBagAllowance($bagAllowance))) {
            throw new \InvalidArgumentException($bagAllowanceArrayErrorMessage, __LINE__);
        }
        if (is_null($bagAllowance) || (is_array($bagAllowance) && empty($bagAllowance))) {
            unset($this->BagAllowance);
        } else {
            $this->BagAllowance = $bagAllowance;
        }
        return $this;
    }
    /**
     * Add item to BagAllowance value
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\BagAllowance $item
     * @return \App|C\ArrayType\ArrayOfBagAllowance
     */
    public function addToBagAllowance(\App|C\StructType\BagAllowance $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \App|C\StructType\BagAllowance) {
            throw new \InvalidArgumentException(sprintf('The BagAllowance property can only contain items of type \App|C\StructType\BagAllowance, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->BagAllowance[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \App|C\StructType\BagAllowance|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \App|C\StructType\BagAllowance|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \App|C\StructType\BagAllowance|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \App|C\StructType\BagAllowance|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \App|C\StructType\BagAllowance|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string BagAllowance
     */
    public function getAttributeName()
    {
        return 'BagAllowance';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \App|C\ArrayType\ArrayOfBagAllowance
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
