<?php

namespace App|C\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfBookingSummary ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfBookingSummary
 * @subpackage Arrays
 */
class ArrayOfBookingSummary extends AbstractStructArrayBase
{
    /**
     * The BookingSummary
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\BookingSummary[]
     */
    public $BookingSummary;
    /**
     * Constructor method for ArrayOfBookingSummary
     * @uses ArrayOfBookingSummary::setBookingSummary()
     * @param \App|C\StructType\BookingSummary[] $bookingSummary
     */
    public function __construct(array $bookingSummary = array())
    {
        $this
            ->setBookingSummary($bookingSummary);
    }
    /**
     * Get BookingSummary value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\BookingSummary[]|null
     */
    public function getBookingSummary()
    {
        return isset($this->BookingSummary) ? $this->BookingSummary : null;
    }
    /**
     * This method is responsible for validating the values passed to the setBookingSummary method
     * This method is willingly generated in order to preserve the one-line inline validation within the setBookingSummary method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateBookingSummaryForArrayConstraintsFromSetBookingSummary(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfBookingSummaryBookingSummaryItem) {
            // validation for constraint: itemType
            if (!$arrayOfBookingSummaryBookingSummaryItem instanceof \App|C\StructType\BookingSummary) {
                $invalidValues[] = is_object($arrayOfBookingSummaryBookingSummaryItem) ? get_class($arrayOfBookingSummaryBookingSummaryItem) : sprintf('%s(%s)', gettype($arrayOfBookingSummaryBookingSummaryItem), var_export($arrayOfBookingSummaryBookingSummaryItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The BookingSummary property can only contain items of type \App|C\StructType\BookingSummary, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set BookingSummary value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\BookingSummary[] $bookingSummary
     * @return \App|C\ArrayType\ArrayOfBookingSummary
     */
    public function setBookingSummary(array $bookingSummary = array())
    {
        // validation for constraint: array
        if ('' !== ($bookingSummaryArrayErrorMessage = self::validateBookingSummaryForArrayConstraintsFromSetBookingSummary($bookingSummary))) {
            throw new \InvalidArgumentException($bookingSummaryArrayErrorMessage, __LINE__);
        }
        if (is_null($bookingSummary) || (is_array($bookingSummary) && empty($bookingSummary))) {
            unset($this->BookingSummary);
        } else {
            $this->BookingSummary = $bookingSummary;
        }
        return $this;
    }
    /**
     * Add item to BookingSummary value
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\BookingSummary $item
     * @return \App|C\ArrayType\ArrayOfBookingSummary
     */
    public function addToBookingSummary(\App|C\StructType\BookingSummary $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \App|C\StructType\BookingSummary) {
            throw new \InvalidArgumentException(sprintf('The BookingSummary property can only contain items of type \App|C\StructType\BookingSummary, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->BookingSummary[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \App|C\StructType\BookingSummary|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \App|C\StructType\BookingSummary|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \App|C\StructType\BookingSummary|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \App|C\StructType\BookingSummary|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \App|C\StructType\BookingSummary|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string BookingSummary
     */
    public function getAttributeName()
    {
        return 'BookingSummary';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \App|C\ArrayType\ArrayOfBookingSummary
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
