<?php

namespace App|C\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfEMDTicket ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfEMDTicket
 * @subpackage Arrays
 */
class ArrayOfEMDTicket extends AbstractStructArrayBase
{
    /**
     * The EMDTicket
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\EMDTicket[]
     */
    public $EMDTicket;
    /**
     * Constructor method for ArrayOfEMDTicket
     * @uses ArrayOfEMDTicket::setEMDTicket()
     * @param \App|C\StructType\EMDTicket[] $eMDTicket
     */
    public function __construct(array $eMDTicket = array())
    {
        $this
            ->setEMDTicket($eMDTicket);
    }
    /**
     * Get EMDTicket value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\EMDTicket[]|null
     */
    public function getEMDTicket()
    {
        return isset($this->EMDTicket) ? $this->EMDTicket : null;
    }
    /**
     * This method is responsible for validating the values passed to the setEMDTicket method
     * This method is willingly generated in order to preserve the one-line inline validation within the setEMDTicket method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateEMDTicketForArrayConstraintsFromSetEMDTicket(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfEMDTicketEMDTicketItem) {
            // validation for constraint: itemType
            if (!$arrayOfEMDTicketEMDTicketItem instanceof \App|C\StructType\EMDTicket) {
                $invalidValues[] = is_object($arrayOfEMDTicketEMDTicketItem) ? get_class($arrayOfEMDTicketEMDTicketItem) : sprintf('%s(%s)', gettype($arrayOfEMDTicketEMDTicketItem), var_export($arrayOfEMDTicketEMDTicketItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The EMDTicket property can only contain items of type \App|C\StructType\EMDTicket, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set EMDTicket value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\EMDTicket[] $eMDTicket
     * @return \App|C\ArrayType\ArrayOfEMDTicket
     */
    public function setEMDTicket(array $eMDTicket = array())
    {
        // validation for constraint: array
        if ('' !== ($eMDTicketArrayErrorMessage = self::validateEMDTicketForArrayConstraintsFromSetEMDTicket($eMDTicket))) {
            throw new \InvalidArgumentException($eMDTicketArrayErrorMessage, __LINE__);
        }
        if (is_null($eMDTicket) || (is_array($eMDTicket) && empty($eMDTicket))) {
            unset($this->EMDTicket);
        } else {
            $this->EMDTicket = $eMDTicket;
        }
        return $this;
    }
    /**
     * Add item to EMDTicket value
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\EMDTicket $item
     * @return \App|C\ArrayType\ArrayOfEMDTicket
     */
    public function addToEMDTicket(\App|C\StructType\EMDTicket $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \App|C\StructType\EMDTicket) {
            throw new \InvalidArgumentException(sprintf('The EMDTicket property can only contain items of type \App|C\StructType\EMDTicket, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->EMDTicket[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \App|C\StructType\EMDTicket|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \App|C\StructType\EMDTicket|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \App|C\StructType\EMDTicket|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \App|C\StructType\EMDTicket|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \App|C\StructType\EMDTicket|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string EMDTicket
     */
    public function getAttributeName()
    {
        return 'EMDTicket';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \App|C\ArrayType\ArrayOfEMDTicket
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
