<?php

namespace App|C\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfETCoupon ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfETCoupon
 * @subpackage Arrays
 */
class ArrayOfETCoupon extends AbstractStructArrayBase
{
    /**
     * The ETCoupon
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\ETCoupon[]
     */
    public $ETCoupon;
    /**
     * Constructor method for ArrayOfETCoupon
     * @uses ArrayOfETCoupon::setETCoupon()
     * @param \App|C\StructType\ETCoupon[] $eTCoupon
     */
    public function __construct(array $eTCoupon = array())
    {
        $this
            ->setETCoupon($eTCoupon);
    }
    /**
     * Get ETCoupon value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\ETCoupon[]|null
     */
    public function getETCoupon()
    {
        return isset($this->ETCoupon) ? $this->ETCoupon : null;
    }
    /**
     * This method is responsible for validating the values passed to the setETCoupon method
     * This method is willingly generated in order to preserve the one-line inline validation within the setETCoupon method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateETCouponForArrayConstraintsFromSetETCoupon(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfETCouponETCouponItem) {
            // validation for constraint: itemType
            if (!$arrayOfETCouponETCouponItem instanceof \App|C\StructType\ETCoupon) {
                $invalidValues[] = is_object($arrayOfETCouponETCouponItem) ? get_class($arrayOfETCouponETCouponItem) : sprintf('%s(%s)', gettype($arrayOfETCouponETCouponItem), var_export($arrayOfETCouponETCouponItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ETCoupon property can only contain items of type \App|C\StructType\ETCoupon, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ETCoupon value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\ETCoupon[] $eTCoupon
     * @return \App|C\ArrayType\ArrayOfETCoupon
     */
    public function setETCoupon(array $eTCoupon = array())
    {
        // validation for constraint: array
        if ('' !== ($eTCouponArrayErrorMessage = self::validateETCouponForArrayConstraintsFromSetETCoupon($eTCoupon))) {
            throw new \InvalidArgumentException($eTCouponArrayErrorMessage, __LINE__);
        }
        if (is_null($eTCoupon) || (is_array($eTCoupon) && empty($eTCoupon))) {
            unset($this->ETCoupon);
        } else {
            $this->ETCoupon = $eTCoupon;
        }
        return $this;
    }
    /**
     * Add item to ETCoupon value
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\ETCoupon $item
     * @return \App|C\ArrayType\ArrayOfETCoupon
     */
    public function addToETCoupon(\App|C\StructType\ETCoupon $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \App|C\StructType\ETCoupon) {
            throw new \InvalidArgumentException(sprintf('The ETCoupon property can only contain items of type \App|C\StructType\ETCoupon, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ETCoupon[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \App|C\StructType\ETCoupon|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \App|C\StructType\ETCoupon|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \App|C\StructType\ETCoupon|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \App|C\StructType\ETCoupon|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \App|C\StructType\ETCoupon|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ETCoupon
     */
    public function getAttributeName()
    {
        return 'ETCoupon';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \App|C\ArrayType\ArrayOfETCoupon
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
