<?php

namespace App|C\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfETCouponFare ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfETCouponFare
 * @subpackage Arrays
 */
class ArrayOfETCouponFare extends AbstractStructArrayBase
{
    /**
     * The ETCouponFare
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\ETCouponFare[]
     */
    public $ETCouponFare;
    /**
     * Constructor method for ArrayOfETCouponFare
     * @uses ArrayOfETCouponFare::setETCouponFare()
     * @param \App|C\StructType\ETCouponFare[] $eTCouponFare
     */
    public function __construct(array $eTCouponFare = array())
    {
        $this
            ->setETCouponFare($eTCouponFare);
    }
    /**
     * Get ETCouponFare value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\ETCouponFare[]|null
     */
    public function getETCouponFare()
    {
        return isset($this->ETCouponFare) ? $this->ETCouponFare : null;
    }
    /**
     * This method is responsible for validating the values passed to the setETCouponFare method
     * This method is willingly generated in order to preserve the one-line inline validation within the setETCouponFare method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateETCouponFareForArrayConstraintsFromSetETCouponFare(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfETCouponFareETCouponFareItem) {
            // validation for constraint: itemType
            if (!$arrayOfETCouponFareETCouponFareItem instanceof \App|C\StructType\ETCouponFare) {
                $invalidValues[] = is_object($arrayOfETCouponFareETCouponFareItem) ? get_class($arrayOfETCouponFareETCouponFareItem) : sprintf('%s(%s)', gettype($arrayOfETCouponFareETCouponFareItem), var_export($arrayOfETCouponFareETCouponFareItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ETCouponFare property can only contain items of type \App|C\StructType\ETCouponFare, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ETCouponFare value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\ETCouponFare[] $eTCouponFare
     * @return \App|C\ArrayType\ArrayOfETCouponFare
     */
    public function setETCouponFare(array $eTCouponFare = array())
    {
        // validation for constraint: array
        if ('' !== ($eTCouponFareArrayErrorMessage = self::validateETCouponFareForArrayConstraintsFromSetETCouponFare($eTCouponFare))) {
            throw new \InvalidArgumentException($eTCouponFareArrayErrorMessage, __LINE__);
        }
        if (is_null($eTCouponFare) || (is_array($eTCouponFare) && empty($eTCouponFare))) {
            unset($this->ETCouponFare);
        } else {
            $this->ETCouponFare = $eTCouponFare;
        }
        return $this;
    }
    /**
     * Add item to ETCouponFare value
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\ETCouponFare $item
     * @return \App|C\ArrayType\ArrayOfETCouponFare
     */
    public function addToETCouponFare(\App|C\StructType\ETCouponFare $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \App|C\StructType\ETCouponFare) {
            throw new \InvalidArgumentException(sprintf('The ETCouponFare property can only contain items of type \App|C\StructType\ETCouponFare, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ETCouponFare[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \App|C\StructType\ETCouponFare|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \App|C\StructType\ETCouponFare|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \App|C\StructType\ETCouponFare|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \App|C\StructType\ETCouponFare|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \App|C\StructType\ETCouponFare|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ETCouponFare
     */
    public function getAttributeName()
    {
        return 'ETCouponFare';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \App|C\ArrayType\ArrayOfETCouponFare
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
