<?php

namespace App|C\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfETTicket ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfETTicket
 * @subpackage Arrays
 */
class ArrayOfETTicket extends AbstractStructArrayBase
{
    /**
     * The ETTicket
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\ETTicket[]
     */
    public $ETTicket;
    /**
     * Constructor method for ArrayOfETTicket
     * @uses ArrayOfETTicket::setETTicket()
     * @param \App|C\StructType\ETTicket[] $eTTicket
     */
    public function __construct(array $eTTicket = array())
    {
        $this
            ->setETTicket($eTTicket);
    }
    /**
     * Get ETTicket value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\ETTicket[]|null
     */
    public function getETTicket()
    {
        return isset($this->ETTicket) ? $this->ETTicket : null;
    }
    /**
     * This method is responsible for validating the values passed to the setETTicket method
     * This method is willingly generated in order to preserve the one-line inline validation within the setETTicket method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateETTicketForArrayConstraintsFromSetETTicket(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfETTicketETTicketItem) {
            // validation for constraint: itemType
            if (!$arrayOfETTicketETTicketItem instanceof \App|C\StructType\ETTicket) {
                $invalidValues[] = is_object($arrayOfETTicketETTicketItem) ? get_class($arrayOfETTicketETTicketItem) : sprintf('%s(%s)', gettype($arrayOfETTicketETTicketItem), var_export($arrayOfETTicketETTicketItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ETTicket property can only contain items of type \App|C\StructType\ETTicket, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ETTicket value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\ETTicket[] $eTTicket
     * @return \App|C\ArrayType\ArrayOfETTicket
     */
    public function setETTicket(array $eTTicket = array())
    {
        // validation for constraint: array
        if ('' !== ($eTTicketArrayErrorMessage = self::validateETTicketForArrayConstraintsFromSetETTicket($eTTicket))) {
            throw new \InvalidArgumentException($eTTicketArrayErrorMessage, __LINE__);
        }
        if (is_null($eTTicket) || (is_array($eTTicket) && empty($eTTicket))) {
            unset($this->ETTicket);
        } else {
            $this->ETTicket = $eTTicket;
        }
        return $this;
    }
    /**
     * Add item to ETTicket value
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\ETTicket $item
     * @return \App|C\ArrayType\ArrayOfETTicket
     */
    public function addToETTicket(\App|C\StructType\ETTicket $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \App|C\StructType\ETTicket) {
            throw new \InvalidArgumentException(sprintf('The ETTicket property can only contain items of type \App|C\StructType\ETTicket, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ETTicket[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \App|C\StructType\ETTicket|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \App|C\StructType\ETTicket|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \App|C\StructType\ETTicket|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \App|C\StructType\ETTicket|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \App|C\StructType\ETTicket|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ETTicket
     */
    public function getAttributeName()
    {
        return 'ETTicket';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \App|C\ArrayType\ArrayOfETTicket
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
