<?php

namespace App|C\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfETTicketCheckin ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfETTicketCheckin
 * @subpackage Arrays
 */
class ArrayOfETTicketCheckin extends AbstractStructArrayBase
{
    /**
     * The ETTicketCheckin
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\ETTicketCheckin[]
     */
    public $ETTicketCheckin;
    /**
     * Constructor method for ArrayOfETTicketCheckin
     * @uses ArrayOfETTicketCheckin::setETTicketCheckin()
     * @param \App|C\StructType\ETTicketCheckin[] $eTTicketCheckin
     */
    public function __construct(array $eTTicketCheckin = array())
    {
        $this
            ->setETTicketCheckin($eTTicketCheckin);
    }
    /**
     * Get ETTicketCheckin value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\ETTicketCheckin[]|null
     */
    public function getETTicketCheckin()
    {
        return isset($this->ETTicketCheckin) ? $this->ETTicketCheckin : null;
    }
    /**
     * This method is responsible for validating the values passed to the setETTicketCheckin method
     * This method is willingly generated in order to preserve the one-line inline validation within the setETTicketCheckin method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateETTicketCheckinForArrayConstraintsFromSetETTicketCheckin(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfETTicketCheckinETTicketCheckinItem) {
            // validation for constraint: itemType
            if (!$arrayOfETTicketCheckinETTicketCheckinItem instanceof \App|C\StructType\ETTicketCheckin) {
                $invalidValues[] = is_object($arrayOfETTicketCheckinETTicketCheckinItem) ? get_class($arrayOfETTicketCheckinETTicketCheckinItem) : sprintf('%s(%s)', gettype($arrayOfETTicketCheckinETTicketCheckinItem), var_export($arrayOfETTicketCheckinETTicketCheckinItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ETTicketCheckin property can only contain items of type \App|C\StructType\ETTicketCheckin, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ETTicketCheckin value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\ETTicketCheckin[] $eTTicketCheckin
     * @return \App|C\ArrayType\ArrayOfETTicketCheckin
     */
    public function setETTicketCheckin(array $eTTicketCheckin = array())
    {
        // validation for constraint: array
        if ('' !== ($eTTicketCheckinArrayErrorMessage = self::validateETTicketCheckinForArrayConstraintsFromSetETTicketCheckin($eTTicketCheckin))) {
            throw new \InvalidArgumentException($eTTicketCheckinArrayErrorMessage, __LINE__);
        }
        if (is_null($eTTicketCheckin) || (is_array($eTTicketCheckin) && empty($eTTicketCheckin))) {
            unset($this->ETTicketCheckin);
        } else {
            $this->ETTicketCheckin = $eTTicketCheckin;
        }
        return $this;
    }
    /**
     * Add item to ETTicketCheckin value
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\ETTicketCheckin $item
     * @return \App|C\ArrayType\ArrayOfETTicketCheckin
     */
    public function addToETTicketCheckin(\App|C\StructType\ETTicketCheckin $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \App|C\StructType\ETTicketCheckin) {
            throw new \InvalidArgumentException(sprintf('The ETTicketCheckin property can only contain items of type \App|C\StructType\ETTicketCheckin, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ETTicketCheckin[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \App|C\StructType\ETTicketCheckin|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \App|C\StructType\ETTicketCheckin|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \App|C\StructType\ETTicketCheckin|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \App|C\StructType\ETTicketCheckin|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \App|C\StructType\ETTicketCheckin|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ETTicketCheckin
     */
    public function getAttributeName()
    {
        return 'ETTicketCheckin';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \App|C\ArrayType\ArrayOfETTicketCheckin
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
