<?php

namespace App|C\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfElectronicDocumentToCancel ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfElectronicDocumentToCancel
 * @subpackage Arrays
 */
class ArrayOfElectronicDocumentToCancel extends AbstractStructArrayBase
{
    /**
     * The ElectronicDocumentToCancel
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\ElectronicDocumentToCancel[]
     */
    public $ElectronicDocumentToCancel;
    /**
     * Constructor method for ArrayOfElectronicDocumentToCancel
     * @uses ArrayOfElectronicDocumentToCancel::setElectronicDocumentToCancel()
     * @param \App|C\StructType\ElectronicDocumentToCancel[] $electronicDocumentToCancel
     */
    public function __construct(array $electronicDocumentToCancel = array())
    {
        $this
            ->setElectronicDocumentToCancel($electronicDocumentToCancel);
    }
    /**
     * Get ElectronicDocumentToCancel value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\ElectronicDocumentToCancel[]|null
     */
    public function getElectronicDocumentToCancel()
    {
        return isset($this->ElectronicDocumentToCancel) ? $this->ElectronicDocumentToCancel : null;
    }
    /**
     * This method is responsible for validating the values passed to the setElectronicDocumentToCancel method
     * This method is willingly generated in order to preserve the one-line inline validation within the setElectronicDocumentToCancel method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateElectronicDocumentToCancelForArrayConstraintsFromSetElectronicDocumentToCancel(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfElectronicDocumentToCancelElectronicDocumentToCancelItem) {
            // validation for constraint: itemType
            if (!$arrayOfElectronicDocumentToCancelElectronicDocumentToCancelItem instanceof \App|C\StructType\ElectronicDocumentToCancel) {
                $invalidValues[] = is_object($arrayOfElectronicDocumentToCancelElectronicDocumentToCancelItem) ? get_class($arrayOfElectronicDocumentToCancelElectronicDocumentToCancelItem) : sprintf('%s(%s)', gettype($arrayOfElectronicDocumentToCancelElectronicDocumentToCancelItem), var_export($arrayOfElectronicDocumentToCancelElectronicDocumentToCancelItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ElectronicDocumentToCancel property can only contain items of type \App|C\StructType\ElectronicDocumentToCancel, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ElectronicDocumentToCancel value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\ElectronicDocumentToCancel[] $electronicDocumentToCancel
     * @return \App|C\ArrayType\ArrayOfElectronicDocumentToCancel
     */
    public function setElectronicDocumentToCancel(array $electronicDocumentToCancel = array())
    {
        // validation for constraint: array
        if ('' !== ($electronicDocumentToCancelArrayErrorMessage = self::validateElectronicDocumentToCancelForArrayConstraintsFromSetElectronicDocumentToCancel($electronicDocumentToCancel))) {
            throw new \InvalidArgumentException($electronicDocumentToCancelArrayErrorMessage, __LINE__);
        }
        if (is_null($electronicDocumentToCancel) || (is_array($electronicDocumentToCancel) && empty($electronicDocumentToCancel))) {
            unset($this->ElectronicDocumentToCancel);
        } else {
            $this->ElectronicDocumentToCancel = $electronicDocumentToCancel;
        }
        return $this;
    }
    /**
     * Add item to ElectronicDocumentToCancel value
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\ElectronicDocumentToCancel $item
     * @return \App|C\ArrayType\ArrayOfElectronicDocumentToCancel
     */
    public function addToElectronicDocumentToCancel(\App|C\StructType\ElectronicDocumentToCancel $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \App|C\StructType\ElectronicDocumentToCancel) {
            throw new \InvalidArgumentException(sprintf('The ElectronicDocumentToCancel property can only contain items of type \App|C\StructType\ElectronicDocumentToCancel, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ElectronicDocumentToCancel[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \App|C\StructType\ElectronicDocumentToCancel|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \App|C\StructType\ElectronicDocumentToCancel|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \App|C\StructType\ElectronicDocumentToCancel|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \App|C\StructType\ElectronicDocumentToCancel|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \App|C\StructType\ElectronicDocumentToCancel|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ElectronicDocumentToCancel
     */
    public function getAttributeName()
    {
        return 'ElectronicDocumentToCancel';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \App|C\ArrayType\ArrayOfElectronicDocumentToCancel
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
