<?php

namespace App|C\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfFareLevelRange ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfFareLevelRange
 * @subpackage Arrays
 */
class ArrayOfFareLevelRange extends AbstractStructArrayBase
{
    /**
     * The FareLevelRange
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\FareLevelRange[]
     */
    public $FareLevelRange;
    /**
     * Constructor method for ArrayOfFareLevelRange
     * @uses ArrayOfFareLevelRange::setFareLevelRange()
     * @param \App|C\StructType\FareLevelRange[] $fareLevelRange
     */
    public function __construct(array $fareLevelRange = array())
    {
        $this
            ->setFareLevelRange($fareLevelRange);
    }
    /**
     * Get FareLevelRange value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\FareLevelRange[]|null
     */
    public function getFareLevelRange()
    {
        return isset($this->FareLevelRange) ? $this->FareLevelRange : null;
    }
    /**
     * This method is responsible for validating the values passed to the setFareLevelRange method
     * This method is willingly generated in order to preserve the one-line inline validation within the setFareLevelRange method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateFareLevelRangeForArrayConstraintsFromSetFareLevelRange(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfFareLevelRangeFareLevelRangeItem) {
            // validation for constraint: itemType
            if (!$arrayOfFareLevelRangeFareLevelRangeItem instanceof \App|C\StructType\FareLevelRange) {
                $invalidValues[] = is_object($arrayOfFareLevelRangeFareLevelRangeItem) ? get_class($arrayOfFareLevelRangeFareLevelRangeItem) : sprintf('%s(%s)', gettype($arrayOfFareLevelRangeFareLevelRangeItem), var_export($arrayOfFareLevelRangeFareLevelRangeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The FareLevelRange property can only contain items of type \App|C\StructType\FareLevelRange, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set FareLevelRange value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\FareLevelRange[] $fareLevelRange
     * @return \App|C\ArrayType\ArrayOfFareLevelRange
     */
    public function setFareLevelRange(array $fareLevelRange = array())
    {
        // validation for constraint: array
        if ('' !== ($fareLevelRangeArrayErrorMessage = self::validateFareLevelRangeForArrayConstraintsFromSetFareLevelRange($fareLevelRange))) {
            throw new \InvalidArgumentException($fareLevelRangeArrayErrorMessage, __LINE__);
        }
        if (is_null($fareLevelRange) || (is_array($fareLevelRange) && empty($fareLevelRange))) {
            unset($this->FareLevelRange);
        } else {
            $this->FareLevelRange = $fareLevelRange;
        }
        return $this;
    }
    /**
     * Add item to FareLevelRange value
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\FareLevelRange $item
     * @return \App|C\ArrayType\ArrayOfFareLevelRange
     */
    public function addToFareLevelRange(\App|C\StructType\FareLevelRange $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \App|C\StructType\FareLevelRange) {
            throw new \InvalidArgumentException(sprintf('The FareLevelRange property can only contain items of type \App|C\StructType\FareLevelRange, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->FareLevelRange[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \App|C\StructType\FareLevelRange|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \App|C\StructType\FareLevelRange|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \App|C\StructType\FareLevelRange|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \App|C\StructType\FareLevelRange|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \App|C\StructType\FareLevelRange|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string FareLevelRange
     */
    public function getAttributeName()
    {
        return 'FareLevelRange';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \App|C\ArrayType\ArrayOfFareLevelRange
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
