<?php

namespace App|C\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfFormOfPaymentConfig ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfFormOfPaymentConfig
 * @subpackage Arrays
 */
class ArrayOfFormOfPaymentConfig extends AbstractStructArrayBase
{
    /**
     * The FormOfPaymentConfig
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\FormOfPaymentConfig[]
     */
    public $FormOfPaymentConfig;
    /**
     * Constructor method for ArrayOfFormOfPaymentConfig
     * @uses ArrayOfFormOfPaymentConfig::setFormOfPaymentConfig()
     * @param \App|C\StructType\FormOfPaymentConfig[] $formOfPaymentConfig
     */
    public function __construct(array $formOfPaymentConfig = array())
    {
        $this
            ->setFormOfPaymentConfig($formOfPaymentConfig);
    }
    /**
     * Get FormOfPaymentConfig value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\FormOfPaymentConfig[]|null
     */
    public function getFormOfPaymentConfig()
    {
        return isset($this->FormOfPaymentConfig) ? $this->FormOfPaymentConfig : null;
    }
    /**
     * This method is responsible for validating the values passed to the setFormOfPaymentConfig method
     * This method is willingly generated in order to preserve the one-line inline validation within the setFormOfPaymentConfig method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateFormOfPaymentConfigForArrayConstraintsFromSetFormOfPaymentConfig(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfFormOfPaymentConfigFormOfPaymentConfigItem) {
            // validation for constraint: itemType
            if (!$arrayOfFormOfPaymentConfigFormOfPaymentConfigItem instanceof \App|C\StructType\FormOfPaymentConfig) {
                $invalidValues[] = is_object($arrayOfFormOfPaymentConfigFormOfPaymentConfigItem) ? get_class($arrayOfFormOfPaymentConfigFormOfPaymentConfigItem) : sprintf('%s(%s)', gettype($arrayOfFormOfPaymentConfigFormOfPaymentConfigItem), var_export($arrayOfFormOfPaymentConfigFormOfPaymentConfigItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The FormOfPaymentConfig property can only contain items of type \App|C\StructType\FormOfPaymentConfig, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set FormOfPaymentConfig value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\FormOfPaymentConfig[] $formOfPaymentConfig
     * @return \App|C\ArrayType\ArrayOfFormOfPaymentConfig
     */
    public function setFormOfPaymentConfig(array $formOfPaymentConfig = array())
    {
        // validation for constraint: array
        if ('' !== ($formOfPaymentConfigArrayErrorMessage = self::validateFormOfPaymentConfigForArrayConstraintsFromSetFormOfPaymentConfig($formOfPaymentConfig))) {
            throw new \InvalidArgumentException($formOfPaymentConfigArrayErrorMessage, __LINE__);
        }
        if (is_null($formOfPaymentConfig) || (is_array($formOfPaymentConfig) && empty($formOfPaymentConfig))) {
            unset($this->FormOfPaymentConfig);
        } else {
            $this->FormOfPaymentConfig = $formOfPaymentConfig;
        }
        return $this;
    }
    /**
     * Add item to FormOfPaymentConfig value
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\FormOfPaymentConfig $item
     * @return \App|C\ArrayType\ArrayOfFormOfPaymentConfig
     */
    public function addToFormOfPaymentConfig(\App|C\StructType\FormOfPaymentConfig $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \App|C\StructType\FormOfPaymentConfig) {
            throw new \InvalidArgumentException(sprintf('The FormOfPaymentConfig property can only contain items of type \App|C\StructType\FormOfPaymentConfig, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->FormOfPaymentConfig[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \App|C\StructType\FormOfPaymentConfig|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \App|C\StructType\FormOfPaymentConfig|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \App|C\StructType\FormOfPaymentConfig|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \App|C\StructType\FormOfPaymentConfig|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \App|C\StructType\FormOfPaymentConfig|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string FormOfPaymentConfig
     */
    public function getAttributeName()
    {
        return 'FormOfPaymentConfig';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \App|C\ArrayType\ArrayOfFormOfPaymentConfig
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
