<?php

namespace App|C\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfFrequentFlyerAward ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfFrequentFlyerAward
 * @subpackage Arrays
 */
class ArrayOfFrequentFlyerAward extends AbstractStructArrayBase
{
    /**
     * The FrequentFlyerAward
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\FrequentFlyerAward[]
     */
    public $FrequentFlyerAward;
    /**
     * Constructor method for ArrayOfFrequentFlyerAward
     * @uses ArrayOfFrequentFlyerAward::setFrequentFlyerAward()
     * @param \App|C\StructType\FrequentFlyerAward[] $frequentFlyerAward
     */
    public function __construct(array $frequentFlyerAward = array())
    {
        $this
            ->setFrequentFlyerAward($frequentFlyerAward);
    }
    /**
     * Get FrequentFlyerAward value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\FrequentFlyerAward[]|null
     */
    public function getFrequentFlyerAward()
    {
        return isset($this->FrequentFlyerAward) ? $this->FrequentFlyerAward : null;
    }
    /**
     * This method is responsible for validating the values passed to the setFrequentFlyerAward method
     * This method is willingly generated in order to preserve the one-line inline validation within the setFrequentFlyerAward method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateFrequentFlyerAwardForArrayConstraintsFromSetFrequentFlyerAward(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfFrequentFlyerAwardFrequentFlyerAwardItem) {
            // validation for constraint: itemType
            if (!$arrayOfFrequentFlyerAwardFrequentFlyerAwardItem instanceof \App|C\StructType\FrequentFlyerAward) {
                $invalidValues[] = is_object($arrayOfFrequentFlyerAwardFrequentFlyerAwardItem) ? get_class($arrayOfFrequentFlyerAwardFrequentFlyerAwardItem) : sprintf('%s(%s)', gettype($arrayOfFrequentFlyerAwardFrequentFlyerAwardItem), var_export($arrayOfFrequentFlyerAwardFrequentFlyerAwardItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The FrequentFlyerAward property can only contain items of type \App|C\StructType\FrequentFlyerAward, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set FrequentFlyerAward value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\FrequentFlyerAward[] $frequentFlyerAward
     * @return \App|C\ArrayType\ArrayOfFrequentFlyerAward
     */
    public function setFrequentFlyerAward(array $frequentFlyerAward = array())
    {
        // validation for constraint: array
        if ('' !== ($frequentFlyerAwardArrayErrorMessage = self::validateFrequentFlyerAwardForArrayConstraintsFromSetFrequentFlyerAward($frequentFlyerAward))) {
            throw new \InvalidArgumentException($frequentFlyerAwardArrayErrorMessage, __LINE__);
        }
        if (is_null($frequentFlyerAward) || (is_array($frequentFlyerAward) && empty($frequentFlyerAward))) {
            unset($this->FrequentFlyerAward);
        } else {
            $this->FrequentFlyerAward = $frequentFlyerAward;
        }
        return $this;
    }
    /**
     * Add item to FrequentFlyerAward value
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\FrequentFlyerAward $item
     * @return \App|C\ArrayType\ArrayOfFrequentFlyerAward
     */
    public function addToFrequentFlyerAward(\App|C\StructType\FrequentFlyerAward $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \App|C\StructType\FrequentFlyerAward) {
            throw new \InvalidArgumentException(sprintf('The FrequentFlyerAward property can only contain items of type \App|C\StructType\FrequentFlyerAward, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->FrequentFlyerAward[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \App|C\StructType\FrequentFlyerAward|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \App|C\StructType\FrequentFlyerAward|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \App|C\StructType\FrequentFlyerAward|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \App|C\StructType\FrequentFlyerAward|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \App|C\StructType\FrequentFlyerAward|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string FrequentFlyerAward
     */
    public function getAttributeName()
    {
        return 'FrequentFlyerAward';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \App|C\ArrayType\ArrayOfFrequentFlyerAward
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
