<?php

namespace App|C\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfOriginDestinationFare ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfOriginDestinationFare
 * @subpackage Arrays
 */
class ArrayOfOriginDestinationFare extends AbstractStructArrayBase
{
    /**
     * The OriginDestinationFare
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\OriginDestinationFare[]
     */
    public $OriginDestinationFare;
    /**
     * Constructor method for ArrayOfOriginDestinationFare
     * @uses ArrayOfOriginDestinationFare::setOriginDestinationFare()
     * @param \App|C\StructType\OriginDestinationFare[] $originDestinationFare
     */
    public function __construct(array $originDestinationFare = array())
    {
        $this
            ->setOriginDestinationFare($originDestinationFare);
    }
    /**
     * Get OriginDestinationFare value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\OriginDestinationFare[]|null
     */
    public function getOriginDestinationFare()
    {
        return isset($this->OriginDestinationFare) ? $this->OriginDestinationFare : null;
    }
    /**
     * This method is responsible for validating the values passed to the setOriginDestinationFare method
     * This method is willingly generated in order to preserve the one-line inline validation within the setOriginDestinationFare method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateOriginDestinationFareForArrayConstraintsFromSetOriginDestinationFare(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfOriginDestinationFareOriginDestinationFareItem) {
            // validation for constraint: itemType
            if (!$arrayOfOriginDestinationFareOriginDestinationFareItem instanceof \App|C\StructType\OriginDestinationFare) {
                $invalidValues[] = is_object($arrayOfOriginDestinationFareOriginDestinationFareItem) ? get_class($arrayOfOriginDestinationFareOriginDestinationFareItem) : sprintf('%s(%s)', gettype($arrayOfOriginDestinationFareOriginDestinationFareItem), var_export($arrayOfOriginDestinationFareOriginDestinationFareItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The OriginDestinationFare property can only contain items of type \App|C\StructType\OriginDestinationFare, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set OriginDestinationFare value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\OriginDestinationFare[] $originDestinationFare
     * @return \App|C\ArrayType\ArrayOfOriginDestinationFare
     */
    public function setOriginDestinationFare(array $originDestinationFare = array())
    {
        // validation for constraint: array
        if ('' !== ($originDestinationFareArrayErrorMessage = self::validateOriginDestinationFareForArrayConstraintsFromSetOriginDestinationFare($originDestinationFare))) {
            throw new \InvalidArgumentException($originDestinationFareArrayErrorMessage, __LINE__);
        }
        if (is_null($originDestinationFare) || (is_array($originDestinationFare) && empty($originDestinationFare))) {
            unset($this->OriginDestinationFare);
        } else {
            $this->OriginDestinationFare = $originDestinationFare;
        }
        return $this;
    }
    /**
     * Add item to OriginDestinationFare value
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\OriginDestinationFare $item
     * @return \App|C\ArrayType\ArrayOfOriginDestinationFare
     */
    public function addToOriginDestinationFare(\App|C\StructType\OriginDestinationFare $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \App|C\StructType\OriginDestinationFare) {
            throw new \InvalidArgumentException(sprintf('The OriginDestinationFare property can only contain items of type \App|C\StructType\OriginDestinationFare, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->OriginDestinationFare[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \App|C\StructType\OriginDestinationFare|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \App|C\StructType\OriginDestinationFare|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \App|C\StructType\OriginDestinationFare|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \App|C\StructType\OriginDestinationFare|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \App|C\StructType\OriginDestinationFare|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string OriginDestinationFare
     */
    public function getAttributeName()
    {
        return 'OriginDestinationFare';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \App|C\ArrayType\ArrayOfOriginDestinationFare
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
