<?php

namespace App|C\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfOriginDestinationTree ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfOriginDestinationTree
 * @subpackage Arrays
 */
class ArrayOfOriginDestinationTree extends AbstractStructArrayBase
{
    /**
     * The OriginDestinationTree
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\OriginDestinationTree[]
     */
    public $OriginDestinationTree;
    /**
     * Constructor method for ArrayOfOriginDestinationTree
     * @uses ArrayOfOriginDestinationTree::setOriginDestinationTree()
     * @param \App|C\StructType\OriginDestinationTree[] $originDestinationTree
     */
    public function __construct(array $originDestinationTree = array())
    {
        $this
            ->setOriginDestinationTree($originDestinationTree);
    }
    /**
     * Get OriginDestinationTree value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\OriginDestinationTree[]|null
     */
    public function getOriginDestinationTree()
    {
        return isset($this->OriginDestinationTree) ? $this->OriginDestinationTree : null;
    }
    /**
     * This method is responsible for validating the values passed to the setOriginDestinationTree method
     * This method is willingly generated in order to preserve the one-line inline validation within the setOriginDestinationTree method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateOriginDestinationTreeForArrayConstraintsFromSetOriginDestinationTree(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfOriginDestinationTreeOriginDestinationTreeItem) {
            // validation for constraint: itemType
            if (!$arrayOfOriginDestinationTreeOriginDestinationTreeItem instanceof \App|C\StructType\OriginDestinationTree) {
                $invalidValues[] = is_object($arrayOfOriginDestinationTreeOriginDestinationTreeItem) ? get_class($arrayOfOriginDestinationTreeOriginDestinationTreeItem) : sprintf('%s(%s)', gettype($arrayOfOriginDestinationTreeOriginDestinationTreeItem), var_export($arrayOfOriginDestinationTreeOriginDestinationTreeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The OriginDestinationTree property can only contain items of type \App|C\StructType\OriginDestinationTree, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set OriginDestinationTree value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\OriginDestinationTree[] $originDestinationTree
     * @return \App|C\ArrayType\ArrayOfOriginDestinationTree
     */
    public function setOriginDestinationTree(array $originDestinationTree = array())
    {
        // validation for constraint: array
        if ('' !== ($originDestinationTreeArrayErrorMessage = self::validateOriginDestinationTreeForArrayConstraintsFromSetOriginDestinationTree($originDestinationTree))) {
            throw new \InvalidArgumentException($originDestinationTreeArrayErrorMessage, __LINE__);
        }
        if (is_null($originDestinationTree) || (is_array($originDestinationTree) && empty($originDestinationTree))) {
            unset($this->OriginDestinationTree);
        } else {
            $this->OriginDestinationTree = $originDestinationTree;
        }
        return $this;
    }
    /**
     * Add item to OriginDestinationTree value
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\OriginDestinationTree $item
     * @return \App|C\ArrayType\ArrayOfOriginDestinationTree
     */
    public function addToOriginDestinationTree(\App|C\StructType\OriginDestinationTree $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \App|C\StructType\OriginDestinationTree) {
            throw new \InvalidArgumentException(sprintf('The OriginDestinationTree property can only contain items of type \App|C\StructType\OriginDestinationTree, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->OriginDestinationTree[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \App|C\StructType\OriginDestinationTree|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \App|C\StructType\OriginDestinationTree|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \App|C\StructType\OriginDestinationTree|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \App|C\StructType\OriginDestinationTree|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \App|C\StructType\OriginDestinationTree|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string OriginDestinationTree
     */
    public function getAttributeName()
    {
        return 'OriginDestinationTree';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \App|C\ArrayType\ArrayOfOriginDestinationTree
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
