<?php

namespace App|C\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSeatRow ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfSeatRow
 * @subpackage Arrays
 */
class ArrayOfSeatRow extends AbstractStructArrayBase
{
    /**
     * The SeatRow
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\SeatRow[]
     */
    public $SeatRow;
    /**
     * Constructor method for ArrayOfSeatRow
     * @uses ArrayOfSeatRow::setSeatRow()
     * @param \App|C\StructType\SeatRow[] $seatRow
     */
    public function __construct(array $seatRow = array())
    {
        $this
            ->setSeatRow($seatRow);
    }
    /**
     * Get SeatRow value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\SeatRow[]|null
     */
    public function getSeatRow()
    {
        return isset($this->SeatRow) ? $this->SeatRow : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSeatRow method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSeatRow method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSeatRowForArrayConstraintsFromSetSeatRow(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfSeatRowSeatRowItem) {
            // validation for constraint: itemType
            if (!$arrayOfSeatRowSeatRowItem instanceof \App|C\StructType\SeatRow) {
                $invalidValues[] = is_object($arrayOfSeatRowSeatRowItem) ? get_class($arrayOfSeatRowSeatRowItem) : sprintf('%s(%s)', gettype($arrayOfSeatRowSeatRowItem), var_export($arrayOfSeatRowSeatRowItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SeatRow property can only contain items of type \App|C\StructType\SeatRow, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SeatRow value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\SeatRow[] $seatRow
     * @return \App|C\ArrayType\ArrayOfSeatRow
     */
    public function setSeatRow(array $seatRow = array())
    {
        // validation for constraint: array
        if ('' !== ($seatRowArrayErrorMessage = self::validateSeatRowForArrayConstraintsFromSetSeatRow($seatRow))) {
            throw new \InvalidArgumentException($seatRowArrayErrorMessage, __LINE__);
        }
        if (is_null($seatRow) || (is_array($seatRow) && empty($seatRow))) {
            unset($this->SeatRow);
        } else {
            $this->SeatRow = $seatRow;
        }
        return $this;
    }
    /**
     * Add item to SeatRow value
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\SeatRow $item
     * @return \App|C\ArrayType\ArrayOfSeatRow
     */
    public function addToSeatRow(\App|C\StructType\SeatRow $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \App|C\StructType\SeatRow) {
            throw new \InvalidArgumentException(sprintf('The SeatRow property can only contain items of type \App|C\StructType\SeatRow, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SeatRow[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \App|C\StructType\SeatRow|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \App|C\StructType\SeatRow|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \App|C\StructType\SeatRow|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \App|C\StructType\SeatRow|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \App|C\StructType\SeatRow|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SeatRow
     */
    public function getAttributeName()
    {
        return 'SeatRow';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \App|C\ArrayType\ArrayOfSeatRow
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
