<?php

namespace App|C\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSpecialServiceReference ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfSpecialServiceReference
 * @subpackage Arrays
 */
class ArrayOfSpecialServiceReference extends AbstractStructArrayBase
{
    /**
     * The SpecialServiceReference
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\SpecialServiceReference[]
     */
    public $SpecialServiceReference;
    /**
     * Constructor method for ArrayOfSpecialServiceReference
     * @uses ArrayOfSpecialServiceReference::setSpecialServiceReference()
     * @param \App|C\StructType\SpecialServiceReference[] $specialServiceReference
     */
    public function __construct(array $specialServiceReference = array())
    {
        $this
            ->setSpecialServiceReference($specialServiceReference);
    }
    /**
     * Get SpecialServiceReference value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\SpecialServiceReference[]|null
     */
    public function getSpecialServiceReference()
    {
        return isset($this->SpecialServiceReference) ? $this->SpecialServiceReference : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSpecialServiceReference method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSpecialServiceReference method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSpecialServiceReferenceForArrayConstraintsFromSetSpecialServiceReference(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfSpecialServiceReferenceSpecialServiceReferenceItem) {
            // validation for constraint: itemType
            if (!$arrayOfSpecialServiceReferenceSpecialServiceReferenceItem instanceof \App|C\StructType\SpecialServiceReference) {
                $invalidValues[] = is_object($arrayOfSpecialServiceReferenceSpecialServiceReferenceItem) ? get_class($arrayOfSpecialServiceReferenceSpecialServiceReferenceItem) : sprintf('%s(%s)', gettype($arrayOfSpecialServiceReferenceSpecialServiceReferenceItem), var_export($arrayOfSpecialServiceReferenceSpecialServiceReferenceItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SpecialServiceReference property can only contain items of type \App|C\StructType\SpecialServiceReference, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SpecialServiceReference value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\SpecialServiceReference[] $specialServiceReference
     * @return \App|C\ArrayType\ArrayOfSpecialServiceReference
     */
    public function setSpecialServiceReference(array $specialServiceReference = array())
    {
        // validation for constraint: array
        if ('' !== ($specialServiceReferenceArrayErrorMessage = self::validateSpecialServiceReferenceForArrayConstraintsFromSetSpecialServiceReference($specialServiceReference))) {
            throw new \InvalidArgumentException($specialServiceReferenceArrayErrorMessage, __LINE__);
        }
        if (is_null($specialServiceReference) || (is_array($specialServiceReference) && empty($specialServiceReference))) {
            unset($this->SpecialServiceReference);
        } else {
            $this->SpecialServiceReference = $specialServiceReference;
        }
        return $this;
    }
    /**
     * Add item to SpecialServiceReference value
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\SpecialServiceReference $item
     * @return \App|C\ArrayType\ArrayOfSpecialServiceReference
     */
    public function addToSpecialServiceReference(\App|C\StructType\SpecialServiceReference $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \App|C\StructType\SpecialServiceReference) {
            throw new \InvalidArgumentException(sprintf('The SpecialServiceReference property can only contain items of type \App|C\StructType\SpecialServiceReference, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SpecialServiceReference[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \App|C\StructType\SpecialServiceReference|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \App|C\StructType\SpecialServiceReference|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \App|C\StructType\SpecialServiceReference|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \App|C\StructType\SpecialServiceReference|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \App|C\StructType\SpecialServiceReference|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SpecialServiceReference
     */
    public function getAttributeName()
    {
        return 'SpecialServiceReference';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \App|C\ArrayType\ArrayOfSpecialServiceReference
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
