<?php

namespace App|C\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ActivateFrequentFlyerAccountRequest StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ActivateFrequentFlyerAccountRequest
 * @subpackage Structs
 */
class ActivateFrequentFlyerAccountRequest extends AbstractRequest
{
    /**
     * The CardDisplayName
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CardDisplayName;
    /**
     * The CustomFrequentFlyerNumber
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CustomFrequentFlyerNumber;
    /**
     * The RefCustomer
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $RefCustomer;
    /**
     * The SponsorFrequentFlyerName
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $SponsorFrequentFlyerName;
    /**
     * The SponsorFrequentFlyerNumber
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $SponsorFrequentFlyerNumber;
    /**
     * Constructor method for ActivateFrequentFlyerAccountRequest
     * @uses ActivateFrequentFlyerAccountRequest::setCardDisplayName()
     * @uses ActivateFrequentFlyerAccountRequest::setCustomFrequentFlyerNumber()
     * @uses ActivateFrequentFlyerAccountRequest::setRefCustomer()
     * @uses ActivateFrequentFlyerAccountRequest::setSponsorFrequentFlyerName()
     * @uses ActivateFrequentFlyerAccountRequest::setSponsorFrequentFlyerNumber()
     * @param string $cardDisplayName
     * @param string $customFrequentFlyerNumber
     * @param string $refCustomer
     * @param string $sponsorFrequentFlyerName
     * @param string $sponsorFrequentFlyerNumber
     */
    public function __construct($cardDisplayName = null, $customFrequentFlyerNumber = null, $refCustomer = null, $sponsorFrequentFlyerName = null, $sponsorFrequentFlyerNumber = null)
    {
        $this
            ->setCardDisplayName($cardDisplayName)
            ->setCustomFrequentFlyerNumber($customFrequentFlyerNumber)
            ->setRefCustomer($refCustomer)
            ->setSponsorFrequentFlyerName($sponsorFrequentFlyerName)
            ->setSponsorFrequentFlyerNumber($sponsorFrequentFlyerNumber);
    }
    /**
     * Get CardDisplayName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCardDisplayName()
    {
        return isset($this->CardDisplayName) ? $this->CardDisplayName : null;
    }
    /**
     * Set CardDisplayName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $cardDisplayName
     * @return \App|C\StructType\ActivateFrequentFlyerAccountRequest
     */
    public function setCardDisplayName($cardDisplayName = null)
    {
        // validation for constraint: string
        if (!is_null($cardDisplayName) && !is_string($cardDisplayName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cardDisplayName, true), gettype($cardDisplayName)), __LINE__);
        }
        if (is_null($cardDisplayName) || (is_array($cardDisplayName) && empty($cardDisplayName))) {
            unset($this->CardDisplayName);
        } else {
            $this->CardDisplayName = $cardDisplayName;
        }
        return $this;
    }
    /**
     * Get CustomFrequentFlyerNumber value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCustomFrequentFlyerNumber()
    {
        return isset($this->CustomFrequentFlyerNumber) ? $this->CustomFrequentFlyerNumber : null;
    }
    /**
     * Set CustomFrequentFlyerNumber value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $customFrequentFlyerNumber
     * @return \App|C\StructType\ActivateFrequentFlyerAccountRequest
     */
    public function setCustomFrequentFlyerNumber($customFrequentFlyerNumber = null)
    {
        // validation for constraint: string
        if (!is_null($customFrequentFlyerNumber) && !is_string($customFrequentFlyerNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($customFrequentFlyerNumber, true), gettype($customFrequentFlyerNumber)), __LINE__);
        }
        if (is_null($customFrequentFlyerNumber) || (is_array($customFrequentFlyerNumber) && empty($customFrequentFlyerNumber))) {
            unset($this->CustomFrequentFlyerNumber);
        } else {
            $this->CustomFrequentFlyerNumber = $customFrequentFlyerNumber;
        }
        return $this;
    }
    /**
     * Get RefCustomer value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getRefCustomer()
    {
        return isset($this->RefCustomer) ? $this->RefCustomer : null;
    }
    /**
     * Set RefCustomer value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $refCustomer
     * @return \App|C\StructType\ActivateFrequentFlyerAccountRequest
     */
    public function setRefCustomer($refCustomer = null)
    {
        // validation for constraint: string
        if (!is_null($refCustomer) && !is_string($refCustomer)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($refCustomer, true), gettype($refCustomer)), __LINE__);
        }
        if (is_null($refCustomer) || (is_array($refCustomer) && empty($refCustomer))) {
            unset($this->RefCustomer);
        } else {
            $this->RefCustomer = $refCustomer;
        }
        return $this;
    }
    /**
     * Get SponsorFrequentFlyerName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSponsorFrequentFlyerName()
    {
        return isset($this->SponsorFrequentFlyerName) ? $this->SponsorFrequentFlyerName : null;
    }
    /**
     * Set SponsorFrequentFlyerName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $sponsorFrequentFlyerName
     * @return \App|C\StructType\ActivateFrequentFlyerAccountRequest
     */
    public function setSponsorFrequentFlyerName($sponsorFrequentFlyerName = null)
    {
        // validation for constraint: string
        if (!is_null($sponsorFrequentFlyerName) && !is_string($sponsorFrequentFlyerName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($sponsorFrequentFlyerName, true), gettype($sponsorFrequentFlyerName)), __LINE__);
        }
        if (is_null($sponsorFrequentFlyerName) || (is_array($sponsorFrequentFlyerName) && empty($sponsorFrequentFlyerName))) {
            unset($this->SponsorFrequentFlyerName);
        } else {
            $this->SponsorFrequentFlyerName = $sponsorFrequentFlyerName;
        }
        return $this;
    }
    /**
     * Get SponsorFrequentFlyerNumber value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSponsorFrequentFlyerNumber()
    {
        return isset($this->SponsorFrequentFlyerNumber) ? $this->SponsorFrequentFlyerNumber : null;
    }
    /**
     * Set SponsorFrequentFlyerNumber value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $sponsorFrequentFlyerNumber
     * @return \App|C\StructType\ActivateFrequentFlyerAccountRequest
     */
    public function setSponsorFrequentFlyerNumber($sponsorFrequentFlyerNumber = null)
    {
        // validation for constraint: string
        if (!is_null($sponsorFrequentFlyerNumber) && !is_string($sponsorFrequentFlyerNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($sponsorFrequentFlyerNumber, true), gettype($sponsorFrequentFlyerNumber)), __LINE__);
        }
        if (is_null($sponsorFrequentFlyerNumber) || (is_array($sponsorFrequentFlyerNumber) && empty($sponsorFrequentFlyerNumber))) {
            unset($this->SponsorFrequentFlyerNumber);
        } else {
            $this->SponsorFrequentFlyerNumber = $sponsorFrequentFlyerNumber;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \App|C\StructType\ActivateFrequentFlyerAccountRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
