<?php

namespace App|C\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CheckinResponse StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:CheckinResponse
 * @subpackage Structs
 */
class CheckinResponse extends AbstractResponse
{
    /**
     * The CheckinResult
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\CheckinResponse
     */
    public $CheckinResult;
    /**
     * The Booking
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\Booking
     */
    public $Booking;
    /**
     * Constructor method for CheckinResponse
     * @uses CheckinResponse::setCheckinResult()
     * @uses CheckinResponse::setBooking()
     * @param \App|C\StructType\CheckinResponse $checkinResult
     * @param \App|C\StructType\Booking $booking
     */
    public function __construct(\App|C\StructType\CheckinResponse $checkinResult = null, \App|C\StructType\Booking $booking = null)
    {
        $this
            ->setCheckinResult($checkinResult)
            ->setBooking($booking);
    }
    /**
     * Get CheckinResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\CheckinResponse|null
     */
    public function getCheckinResult()
    {
        return isset($this->CheckinResult) ? $this->CheckinResult : null;
    }
    /**
     * Set CheckinResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\StructType\CheckinResponse $checkinResult
     * @return \App|C\StructType\CheckinResponse
     */
    public function setCheckinResult(\App|C\StructType\CheckinResponse $checkinResult = null)
    {
        if (is_null($checkinResult) || (is_array($checkinResult) && empty($checkinResult))) {
            unset($this->CheckinResult);
        } else {
            $this->CheckinResult = $checkinResult;
        }
        return $this;
    }
    /**
     * Get Booking value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\Booking|null
     */
    public function getBooking()
    {
        return isset($this->Booking) ? $this->Booking : null;
    }
    /**
     * Set Booking value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\StructType\Booking $booking
     * @return \App|C\StructType\CheckinResponse
     */
    public function setBooking(\App|C\StructType\Booking $booking = null)
    {
        if (is_null($booking) || (is_array($booking) && empty($booking))) {
            unset($this->Booking);
        } else {
            $this->Booking = $booking;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \App|C\StructType\CheckinResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
