<?php

namespace App|C\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ETTicketFareTarget StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ETTicketFareTarget
 * @subpackage Structs
 */
class ETTicketFareTarget extends ApiObject
{
    /**
     * The CouponOrders
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\ArrayType\ArrayOfint
     */
    public $CouponOrders;
    /**
     * The RefETTicketFare
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $RefETTicketFare;
    /**
     * Constructor method for ETTicketFareTarget
     * @uses ETTicketFareTarget::setCouponOrders()
     * @uses ETTicketFareTarget::setRefETTicketFare()
     * @param \App|C\ArrayType\ArrayOfint $couponOrders
     * @param string $refETTicketFare
     */
    public function __construct(\App|C\ArrayType\ArrayOfint $couponOrders = null, $refETTicketFare = null)
    {
        $this
            ->setCouponOrders($couponOrders)
            ->setRefETTicketFare($refETTicketFare);
    }
    /**
     * Get CouponOrders value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\ArrayType\ArrayOfint|null
     */
    public function getCouponOrders()
    {
        return isset($this->CouponOrders) ? $this->CouponOrders : null;
    }
    /**
     * Set CouponOrders value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\ArrayType\ArrayOfint $couponOrders
     * @return \App|C\StructType\ETTicketFareTarget
     */
    public function setCouponOrders(\App|C\ArrayType\ArrayOfint $couponOrders = null)
    {
        if (is_null($couponOrders) || (is_array($couponOrders) && empty($couponOrders))) {
            unset($this->CouponOrders);
        } else {
            $this->CouponOrders = $couponOrders;
        }
        return $this;
    }
    /**
     * Get RefETTicketFare value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getRefETTicketFare()
    {
        return isset($this->RefETTicketFare) ? $this->RefETTicketFare : null;
    }
    /**
     * Set RefETTicketFare value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $refETTicketFare
     * @return \App|C\StructType\ETTicketFareTarget
     */
    public function setRefETTicketFare($refETTicketFare = null)
    {
        // validation for constraint: string
        if (!is_null($refETTicketFare) && !is_string($refETTicketFare)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($refETTicketFare, true), gettype($refETTicketFare)), __LINE__);
        }
        if (is_null($refETTicketFare) || (is_array($refETTicketFare) && empty($refETTicketFare))) {
            unset($this->RefETTicketFare);
        } else {
            $this->RefETTicketFare = $refETTicketFare;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \App|C\StructType\ETTicketFareTarget
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
