<?php

namespace App|C\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ETTicketTarget StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ETTicketTarget
 * @subpackage Structs
 */
class ETTicketTarget extends ElectronicDocument
{
    /**
     * The CouponOrders
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\ArrayType\ArrayOfint
     */
    public $CouponOrders;
    /**
     * Constructor method for ETTicketTarget
     * @uses ETTicketTarget::setCouponOrders()
     * @param \App|C\ArrayType\ArrayOfint $couponOrders
     */
    public function __construct(\App|C\ArrayType\ArrayOfint $couponOrders = null)
    {
        $this
            ->setCouponOrders($couponOrders);
    }
    /**
     * Get CouponOrders value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\ArrayType\ArrayOfint|null
     */
    public function getCouponOrders()
    {
        return isset($this->CouponOrders) ? $this->CouponOrders : null;
    }
    /**
     * Set CouponOrders value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\ArrayType\ArrayOfint $couponOrders
     * @return \App|C\StructType\ETTicketTarget
     */
    public function setCouponOrders(\App|C\ArrayType\ArrayOfint $couponOrders = null)
    {
        if (is_null($couponOrders) || (is_array($couponOrders) && empty($couponOrders))) {
            unset($this->CouponOrders);
        } else {
            $this->CouponOrders = $couponOrders;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \App|C\StructType\ETTicketTarget
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
