<?php

namespace App|C\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FareInfoOptions StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:FareInfoOptions
 * @subpackage Structs
 */
class FareInfoOptions extends FareInfo
{
    /**
     * The FareRules
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\ArrayType\ArrayOfFareRule
     */
    public $FareRules;
    /**
     * The Itineraries
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\ArrayType\ArrayOfItinerary
     */
    public $Itineraries;
    /**
     * Constructor method for FareInfoOptions
     * @uses FareInfoOptions::setFareRules()
     * @uses FareInfoOptions::setItineraries()
     * @param \App|C\ArrayType\ArrayOfFareRule $fareRules
     * @param \App|C\ArrayType\ArrayOfItinerary $itineraries
     */
    public function __construct(\App|C\ArrayType\ArrayOfFareRule $fareRules = null, \App|C\ArrayType\ArrayOfItinerary $itineraries = null)
    {
        $this
            ->setFareRules($fareRules)
            ->setItineraries($itineraries);
    }
    /**
     * Get FareRules value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\ArrayType\ArrayOfFareRule|null
     */
    public function getFareRules()
    {
        return isset($this->FareRules) ? $this->FareRules : null;
    }
    /**
     * Set FareRules value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\ArrayType\ArrayOfFareRule $fareRules
     * @return \App|C\StructType\FareInfoOptions
     */
    public function setFareRules(\App|C\ArrayType\ArrayOfFareRule $fareRules = null)
    {
        if (is_null($fareRules) || (is_array($fareRules) && empty($fareRules))) {
            unset($this->FareRules);
        } else {
            $this->FareRules = $fareRules;
        }
        return $this;
    }
    /**
     * Get Itineraries value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\ArrayType\ArrayOfItinerary|null
     */
    public function getItineraries()
    {
        return isset($this->Itineraries) ? $this->Itineraries : null;
    }
    /**
     * Set Itineraries value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\ArrayType\ArrayOfItinerary $itineraries
     * @return \App|C\StructType\FareInfoOptions
     */
    public function setItineraries(\App|C\ArrayType\ArrayOfItinerary $itineraries = null)
    {
        if (is_null($itineraries) || (is_array($itineraries) && empty($itineraries))) {
            unset($this->Itineraries);
        } else {
            $this->Itineraries = $itineraries;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \App|C\StructType\FareInfoOptions
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
