<?php

namespace App|C\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FareInfoPrepare StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:FareInfoPrepare
 * @subpackage Structs
 */
class FareInfoPrepare extends FareInfoEMD
{
    /**
     * The EMDTicketFareOptions
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\ArrayType\ArrayOfEMDTicketFareOption
     */
    public $EMDTicketFareOptions;
    /**
     * Constructor method for FareInfoPrepare
     * @uses FareInfoPrepare::setEMDTicketFareOptions()
     * @param \App|C\ArrayType\ArrayOfEMDTicketFareOption $eMDTicketFareOptions
     */
    public function __construct(\App|C\ArrayType\ArrayOfEMDTicketFareOption $eMDTicketFareOptions = null)
    {
        $this
            ->setEMDTicketFareOptions($eMDTicketFareOptions);
    }
    /**
     * Get EMDTicketFareOptions value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\ArrayType\ArrayOfEMDTicketFareOption|null
     */
    public function getEMDTicketFareOptions()
    {
        return isset($this->EMDTicketFareOptions) ? $this->EMDTicketFareOptions : null;
    }
    /**
     * Set EMDTicketFareOptions value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\ArrayType\ArrayOfEMDTicketFareOption $eMDTicketFareOptions
     * @return \App|C\StructType\FareInfoPrepare
     */
    public function setEMDTicketFareOptions(\App|C\ArrayType\ArrayOfEMDTicketFareOption $eMDTicketFareOptions = null)
    {
        if (is_null($eMDTicketFareOptions) || (is_array($eMDTicketFareOptions) && empty($eMDTicketFareOptions))) {
            unset($this->EMDTicketFareOptions);
        } else {
            $this->EMDTicketFareOptions = $eMDTicketFareOptions;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \App|C\StructType\FareInfoPrepare
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
