<?php

namespace App|C\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FareLevelRange StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:FareLevelRange
 * @subpackage Structs
 */
class FareLevelRange extends ApiObject
{
    /**
     * The Max
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $Max;
    /**
     * The Min
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $Min;
    /**
     * Constructor method for FareLevelRange
     * @uses FareLevelRange::setMax()
     * @uses FareLevelRange::setMin()
     * @param int $max
     * @param int $min
     */
    public function __construct($max = null, $min = null)
    {
        $this
            ->setMax($max)
            ->setMin($min);
    }
    /**
     * Get Max value
     * @return int|null
     */
    public function getMax()
    {
        return $this->Max;
    }
    /**
     * Set Max value
     * @param int $max
     * @return \App|C\StructType\FareLevelRange
     */
    public function setMax($max = null)
    {
        // validation for constraint: int
        if (!is_null($max) && !(is_int($max) || ctype_digit($max))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($max, true), gettype($max)), __LINE__);
        }
        $this->Max = $max;
        return $this;
    }
    /**
     * Get Min value
     * @return int|null
     */
    public function getMin()
    {
        return $this->Min;
    }
    /**
     * Set Min value
     * @param int $min
     * @return \App|C\StructType\FareLevelRange
     */
    public function setMin($min = null)
    {
        // validation for constraint: int
        if (!is_null($min) && !(is_int($min) || ctype_digit($min))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($min, true), gettype($min)), __LINE__);
        }
        $this->Min = $min;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \App|C\StructType\FareLevelRange
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
