<?php

namespace App|C\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FormOfPaymentRedirectInfo StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:FormOfPaymentRedirectInfo
 * @subpackage Structs
 */
class FormOfPaymentRedirectInfo extends ApiObject
{
    /**
     * The AcceptUrl
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $AcceptUrl;
    /**
     * The CancelUrl
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CancelUrl;
    /**
     * The DeclineUrl
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $DeclineUrl;
    /**
     * Constructor method for FormOfPaymentRedirectInfo
     * @uses FormOfPaymentRedirectInfo::setAcceptUrl()
     * @uses FormOfPaymentRedirectInfo::setCancelUrl()
     * @uses FormOfPaymentRedirectInfo::setDeclineUrl()
     * @param string $acceptUrl
     * @param string $cancelUrl
     * @param string $declineUrl
     */
    public function __construct($acceptUrl = null, $cancelUrl = null, $declineUrl = null)
    {
        $this
            ->setAcceptUrl($acceptUrl)
            ->setCancelUrl($cancelUrl)
            ->setDeclineUrl($declineUrl);
    }
    /**
     * Get AcceptUrl value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getAcceptUrl()
    {
        return isset($this->AcceptUrl) ? $this->AcceptUrl : null;
    }
    /**
     * Set AcceptUrl value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $acceptUrl
     * @return \App|C\StructType\FormOfPaymentRedirectInfo
     */
    public function setAcceptUrl($acceptUrl = null)
    {
        // validation for constraint: string
        if (!is_null($acceptUrl) && !is_string($acceptUrl)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($acceptUrl, true), gettype($acceptUrl)), __LINE__);
        }
        if (is_null($acceptUrl) || (is_array($acceptUrl) && empty($acceptUrl))) {
            unset($this->AcceptUrl);
        } else {
            $this->AcceptUrl = $acceptUrl;
        }
        return $this;
    }
    /**
     * Get CancelUrl value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCancelUrl()
    {
        return isset($this->CancelUrl) ? $this->CancelUrl : null;
    }
    /**
     * Set CancelUrl value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $cancelUrl
     * @return \App|C\StructType\FormOfPaymentRedirectInfo
     */
    public function setCancelUrl($cancelUrl = null)
    {
        // validation for constraint: string
        if (!is_null($cancelUrl) && !is_string($cancelUrl)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cancelUrl, true), gettype($cancelUrl)), __LINE__);
        }
        if (is_null($cancelUrl) || (is_array($cancelUrl) && empty($cancelUrl))) {
            unset($this->CancelUrl);
        } else {
            $this->CancelUrl = $cancelUrl;
        }
        return $this;
    }
    /**
     * Get DeclineUrl value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDeclineUrl()
    {
        return isset($this->DeclineUrl) ? $this->DeclineUrl : null;
    }
    /**
     * Set DeclineUrl value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $declineUrl
     * @return \App|C\StructType\FormOfPaymentRedirectInfo
     */
    public function setDeclineUrl($declineUrl = null)
    {
        // validation for constraint: string
        if (!is_null($declineUrl) && !is_string($declineUrl)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($declineUrl, true), gettype($declineUrl)), __LINE__);
        }
        if (is_null($declineUrl) || (is_array($declineUrl) && empty($declineUrl))) {
            unset($this->DeclineUrl);
        } else {
            $this->DeclineUrl = $declineUrl;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \App|C\StructType\FormOfPaymentRedirectInfo
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
