<?php

namespace App|C\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ModifyBookingRequest StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ModifyBookingRequest
 * @subpackage Structs
 */
class ModifyBookingRequest extends AbstractRequest
{
    /**
     * The EMDTicketFares
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\ArrayType\ArrayOfEMDTicketFare
     */
    public $EMDTicketFares;
    /**
     * The Passengers
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\ArrayType\ArrayOfPassenger
     */
    public $Passengers;
    /**
     * The RemovedEMDTicketFares
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\ArrayType\ArrayOfstring
     */
    public $RemovedEMDTicketFares;
    /**
     * The RemovedSpecialServices
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\ArrayType\ArrayOfSpecialServiceReference
     */
    public $RemovedSpecialServices;
    /**
     * The SpecialServices
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\ArrayType\ArrayOfSpecialService
     */
    public $SpecialServices;
    /**
     * The UniqueID
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\UniqueID
     */
    public $UniqueID;
    /**
     * The Verification
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\Verification
     */
    public $Verification;
    /**
     * Constructor method for ModifyBookingRequest
     * @uses ModifyBookingRequest::setEMDTicketFares()
     * @uses ModifyBookingRequest::setPassengers()
     * @uses ModifyBookingRequest::setRemovedEMDTicketFares()
     * @uses ModifyBookingRequest::setRemovedSpecialServices()
     * @uses ModifyBookingRequest::setSpecialServices()
     * @uses ModifyBookingRequest::setUniqueID()
     * @uses ModifyBookingRequest::setVerification()
     * @param \App|C\ArrayType\ArrayOfEMDTicketFare $eMDTicketFares
     * @param \App|C\ArrayType\ArrayOfPassenger $passengers
     * @param \App|C\ArrayType\ArrayOfstring $removedEMDTicketFares
     * @param \App|C\ArrayType\ArrayOfSpecialServiceReference $removedSpecialServices
     * @param \App|C\ArrayType\ArrayOfSpecialService $specialServices
     * @param \App|C\StructType\UniqueID $uniqueID
     * @param \App|C\StructType\Verification $verification
     */
    public function __construct(\App|C\ArrayType\ArrayOfEMDTicketFare $eMDTicketFares = null, \App|C\ArrayType\ArrayOfPassenger $passengers = null, \App|C\ArrayType\ArrayOfstring $removedEMDTicketFares = null, \App|C\ArrayType\ArrayOfSpecialServiceReference $removedSpecialServices = null, \App|C\ArrayType\ArrayOfSpecialService $specialServices = null, \App|C\StructType\UniqueID $uniqueID = null, \App|C\StructType\Verification $verification = null)
    {
        $this
            ->setEMDTicketFares($eMDTicketFares)
            ->setPassengers($passengers)
            ->setRemovedEMDTicketFares($removedEMDTicketFares)
            ->setRemovedSpecialServices($removedSpecialServices)
            ->setSpecialServices($specialServices)
            ->setUniqueID($uniqueID)
            ->setVerification($verification);
    }
    /**
     * Get EMDTicketFares value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\ArrayType\ArrayOfEMDTicketFare|null
     */
    public function getEMDTicketFares()
    {
        return isset($this->EMDTicketFares) ? $this->EMDTicketFares : null;
    }
    /**
     * Set EMDTicketFares value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\ArrayType\ArrayOfEMDTicketFare $eMDTicketFares
     * @return \App|C\StructType\ModifyBookingRequest
     */
    public function setEMDTicketFares(\App|C\ArrayType\ArrayOfEMDTicketFare $eMDTicketFares = null)
    {
        if (is_null($eMDTicketFares) || (is_array($eMDTicketFares) && empty($eMDTicketFares))) {
            unset($this->EMDTicketFares);
        } else {
            $this->EMDTicketFares = $eMDTicketFares;
        }
        return $this;
    }
    /**
     * Get Passengers value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\ArrayType\ArrayOfPassenger|null
     */
    public function getPassengers()
    {
        return isset($this->Passengers) ? $this->Passengers : null;
    }
    /**
     * Set Passengers value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\ArrayType\ArrayOfPassenger $passengers
     * @return \App|C\StructType\ModifyBookingRequest
     */
    public function setPassengers(\App|C\ArrayType\ArrayOfPassenger $passengers = null)
    {
        if (is_null($passengers) || (is_array($passengers) && empty($passengers))) {
            unset($this->Passengers);
        } else {
            $this->Passengers = $passengers;
        }
        return $this;
    }
    /**
     * Get RemovedEMDTicketFares value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\ArrayType\ArrayOfstring|null
     */
    public function getRemovedEMDTicketFares()
    {
        return isset($this->RemovedEMDTicketFares) ? $this->RemovedEMDTicketFares : null;
    }
    /**
     * Set RemovedEMDTicketFares value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\ArrayType\ArrayOfstring $removedEMDTicketFares
     * @return \App|C\StructType\ModifyBookingRequest
     */
    public function setRemovedEMDTicketFares(\App|C\ArrayType\ArrayOfstring $removedEMDTicketFares = null)
    {
        if (is_null($removedEMDTicketFares) || (is_array($removedEMDTicketFares) && empty($removedEMDTicketFares))) {
            unset($this->RemovedEMDTicketFares);
        } else {
            $this->RemovedEMDTicketFares = $removedEMDTicketFares;
        }
        return $this;
    }
    /**
     * Get RemovedSpecialServices value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\ArrayType\ArrayOfSpecialServiceReference|null
     */
    public function getRemovedSpecialServices()
    {
        return isset($this->RemovedSpecialServices) ? $this->RemovedSpecialServices : null;
    }
    /**
     * Set RemovedSpecialServices value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\ArrayType\ArrayOfSpecialServiceReference $removedSpecialServices
     * @return \App|C\StructType\ModifyBookingRequest
     */
    public function setRemovedSpecialServices(\App|C\ArrayType\ArrayOfSpecialServiceReference $removedSpecialServices = null)
    {
        if (is_null($removedSpecialServices) || (is_array($removedSpecialServices) && empty($removedSpecialServices))) {
            unset($this->RemovedSpecialServices);
        } else {
            $this->RemovedSpecialServices = $removedSpecialServices;
        }
        return $this;
    }
    /**
     * Get SpecialServices value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\ArrayType\ArrayOfSpecialService|null
     */
    public function getSpecialServices()
    {
        return isset($this->SpecialServices) ? $this->SpecialServices : null;
    }
    /**
     * Set SpecialServices value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\ArrayType\ArrayOfSpecialService $specialServices
     * @return \App|C\StructType\ModifyBookingRequest
     */
    public function setSpecialServices(\App|C\ArrayType\ArrayOfSpecialService $specialServices = null)
    {
        if (is_null($specialServices) || (is_array($specialServices) && empty($specialServices))) {
            unset($this->SpecialServices);
        } else {
            $this->SpecialServices = $specialServices;
        }
        return $this;
    }
    /**
     * Get UniqueID value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\UniqueID|null
     */
    public function getUniqueID()
    {
        return isset($this->UniqueID) ? $this->UniqueID : null;
    }
    /**
     * Set UniqueID value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\StructType\UniqueID $uniqueID
     * @return \App|C\StructType\ModifyBookingRequest
     */
    public function setUniqueID(\App|C\StructType\UniqueID $uniqueID = null)
    {
        if (is_null($uniqueID) || (is_array($uniqueID) && empty($uniqueID))) {
            unset($this->UniqueID);
        } else {
            $this->UniqueID = $uniqueID;
        }
        return $this;
    }
    /**
     * Get Verification value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\Verification|null
     */
    public function getVerification()
    {
        return isset($this->Verification) ? $this->Verification : null;
    }
    /**
     * Set Verification value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\StructType\Verification $verification
     * @return \App|C\StructType\ModifyBookingRequest
     */
    public function setVerification(\App|C\StructType\Verification $verification = null)
    {
        if (is_null($verification) || (is_array($verification) && empty($verification))) {
            unset($this->Verification);
        } else {
            $this->Verification = $verification;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \App|C\StructType\ModifyBookingRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
