<?php

namespace App|C\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for OriginDestination StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:OriginDestination
 * @subpackage Structs
 */
class OriginDestination extends CityPair
{
    /**
     * The TargetDate
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $TargetDate;
    /**
     * Constructor method for OriginDestination
     * @uses OriginDestination::setTargetDate()
     * @param string $targetDate
     */
    public function __construct($targetDate = null)
    {
        $this
            ->setTargetDate($targetDate);
    }
    /**
     * Get TargetDate value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTargetDate()
    {
        return isset($this->TargetDate) ? $this->TargetDate : null;
    }
    /**
     * Set TargetDate value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $targetDate
     * @return \App|C\StructType\OriginDestination
     */
    public function setTargetDate($targetDate = null)
    {
        // validation for constraint: string
        if (!is_null($targetDate) && !is_string($targetDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($targetDate, true), gettype($targetDate)), __LINE__);
        }
        if (is_null($targetDate) || (is_array($targetDate) && empty($targetDate))) {
            unset($this->TargetDate);
        } else {
            $this->TargetDate = $targetDate;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \App|C\StructType\OriginDestination
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
