<?php

namespace App|C\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PrepareExchangeRequest StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:PrepareExchangeRequest
 * @subpackage Structs
 */
class PrepareExchangeRequest extends AbstractRequest
{
    /**
     * The FareInfo
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\FareInfoBase
     */
    public $FareInfo;
    /**
     * The Offer
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\OfferIn
     */
    public $Offer;
    /**
     * The PromoCode
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $PromoCode;
    /**
     * The Segments
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\ArrayType\ArrayOfSegmentBooking
     */
    public $Segments;
    /**
     * The TicketFaresToExchange
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\ArrayType\ArrayOfETTicketFareTarget
     */
    public $TicketFaresToExchange;
    /**
     * The UniqueID
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\UniqueID
     */
    public $UniqueID;
    /**
     * The Verification
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\Verification
     */
    public $Verification;
    /**
     * Constructor method for PrepareExchangeRequest
     * @uses PrepareExchangeRequest::setFareInfo()
     * @uses PrepareExchangeRequest::setOffer()
     * @uses PrepareExchangeRequest::setPromoCode()
     * @uses PrepareExchangeRequest::setSegments()
     * @uses PrepareExchangeRequest::setTicketFaresToExchange()
     * @uses PrepareExchangeRequest::setUniqueID()
     * @uses PrepareExchangeRequest::setVerification()
     * @param \App|C\StructType\FareInfoBase $fareInfo
     * @param \App|C\StructType\OfferIn $offer
     * @param string $promoCode
     * @param \App|C\ArrayType\ArrayOfSegmentBooking $segments
     * @param \App|C\ArrayType\ArrayOfETTicketFareTarget $ticketFaresToExchange
     * @param \App|C\StructType\UniqueID $uniqueID
     * @param \App|C\StructType\Verification $verification
     */
    public function __construct(\App|C\StructType\FareInfoBase $fareInfo = null, \App|C\StructType\OfferIn $offer = null, $promoCode = null, \App|C\ArrayType\ArrayOfSegmentBooking $segments = null, \App|C\ArrayType\ArrayOfETTicketFareTarget $ticketFaresToExchange = null, \App|C\StructType\UniqueID $uniqueID = null, \App|C\StructType\Verification $verification = null)
    {
        $this
            ->setFareInfo($fareInfo)
            ->setOffer($offer)
            ->setPromoCode($promoCode)
            ->setSegments($segments)
            ->setTicketFaresToExchange($ticketFaresToExchange)
            ->setUniqueID($uniqueID)
            ->setVerification($verification);
    }
    /**
     * Get FareInfo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\FareInfoBase|null
     */
    public function getFareInfo()
    {
        return isset($this->FareInfo) ? $this->FareInfo : null;
    }
    /**
     * Set FareInfo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\StructType\FareInfoBase $fareInfo
     * @return \App|C\StructType\PrepareExchangeRequest
     */
    public function setFareInfo(\App|C\StructType\FareInfoBase $fareInfo = null)
    {
        if (is_null($fareInfo) || (is_array($fareInfo) && empty($fareInfo))) {
            unset($this->FareInfo);
        } else {
            $this->FareInfo = $fareInfo;
        }
        return $this;
    }
    /**
     * Get Offer value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\OfferIn|null
     */
    public function getOffer()
    {
        return isset($this->Offer) ? $this->Offer : null;
    }
    /**
     * Set Offer value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\StructType\OfferIn $offer
     * @return \App|C\StructType\PrepareExchangeRequest
     */
    public function setOffer(\App|C\StructType\OfferIn $offer = null)
    {
        if (is_null($offer) || (is_array($offer) && empty($offer))) {
            unset($this->Offer);
        } else {
            $this->Offer = $offer;
        }
        return $this;
    }
    /**
     * Get PromoCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPromoCode()
    {
        return isset($this->PromoCode) ? $this->PromoCode : null;
    }
    /**
     * Set PromoCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $promoCode
     * @return \App|C\StructType\PrepareExchangeRequest
     */
    public function setPromoCode($promoCode = null)
    {
        // validation for constraint: string
        if (!is_null($promoCode) && !is_string($promoCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($promoCode, true), gettype($promoCode)), __LINE__);
        }
        if (is_null($promoCode) || (is_array($promoCode) && empty($promoCode))) {
            unset($this->PromoCode);
        } else {
            $this->PromoCode = $promoCode;
        }
        return $this;
    }
    /**
     * Get Segments value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\ArrayType\ArrayOfSegmentBooking|null
     */
    public function getSegments()
    {
        return isset($this->Segments) ? $this->Segments : null;
    }
    /**
     * Set Segments value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\ArrayType\ArrayOfSegmentBooking $segments
     * @return \App|C\StructType\PrepareExchangeRequest
     */
    public function setSegments(\App|C\ArrayType\ArrayOfSegmentBooking $segments = null)
    {
        if (is_null($segments) || (is_array($segments) && empty($segments))) {
            unset($this->Segments);
        } else {
            $this->Segments = $segments;
        }
        return $this;
    }
    /**
     * Get TicketFaresToExchange value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\ArrayType\ArrayOfETTicketFareTarget|null
     */
    public function getTicketFaresToExchange()
    {
        return isset($this->TicketFaresToExchange) ? $this->TicketFaresToExchange : null;
    }
    /**
     * Set TicketFaresToExchange value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\ArrayType\ArrayOfETTicketFareTarget $ticketFaresToExchange
     * @return \App|C\StructType\PrepareExchangeRequest
     */
    public function setTicketFaresToExchange(\App|C\ArrayType\ArrayOfETTicketFareTarget $ticketFaresToExchange = null)
    {
        if (is_null($ticketFaresToExchange) || (is_array($ticketFaresToExchange) && empty($ticketFaresToExchange))) {
            unset($this->TicketFaresToExchange);
        } else {
            $this->TicketFaresToExchange = $ticketFaresToExchange;
        }
        return $this;
    }
    /**
     * Get UniqueID value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\UniqueID|null
     */
    public function getUniqueID()
    {
        return isset($this->UniqueID) ? $this->UniqueID : null;
    }
    /**
     * Set UniqueID value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\StructType\UniqueID $uniqueID
     * @return \App|C\StructType\PrepareExchangeRequest
     */
    public function setUniqueID(\App|C\StructType\UniqueID $uniqueID = null)
    {
        if (is_null($uniqueID) || (is_array($uniqueID) && empty($uniqueID))) {
            unset($this->UniqueID);
        } else {
            $this->UniqueID = $uniqueID;
        }
        return $this;
    }
    /**
     * Get Verification value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\Verification|null
     */
    public function getVerification()
    {
        return isset($this->Verification) ? $this->Verification : null;
    }
    /**
     * Set Verification value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\StructType\Verification $verification
     * @return \App|C\StructType\PrepareExchangeRequest
     */
    public function setVerification(\App|C\StructType\Verification $verification = null)
    {
        if (is_null($verification) || (is_array($verification) && empty($verification))) {
            unset($this->Verification);
        } else {
            $this->Verification = $verification;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \App|C\StructType\PrepareExchangeRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
