<?php

namespace App|C\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SearchBookingResponse StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:SearchBookingResponse
 * @subpackage Structs
 */
class SearchBookingResponse extends AbstractResponse
{
    /**
     * The SearchBookingResult
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\SearchBookingResponse
     */
    public $SearchBookingResult;
    /**
     * The BookingSummaries
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\ArrayType\ArrayOfBookingSummary
     */
    public $BookingSummaries;
    /**
     * Constructor method for SearchBookingResponse
     * @uses SearchBookingResponse::setSearchBookingResult()
     * @uses SearchBookingResponse::setBookingSummaries()
     * @param \App|C\StructType\SearchBookingResponse $searchBookingResult
     * @param \App|C\ArrayType\ArrayOfBookingSummary $bookingSummaries
     */
    public function __construct(\App|C\StructType\SearchBookingResponse $searchBookingResult = null, \App|C\ArrayType\ArrayOfBookingSummary $bookingSummaries = null)
    {
        $this
            ->setSearchBookingResult($searchBookingResult)
            ->setBookingSummaries($bookingSummaries);
    }
    /**
     * Get SearchBookingResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\SearchBookingResponse|null
     */
    public function getSearchBookingResult()
    {
        return isset($this->SearchBookingResult) ? $this->SearchBookingResult : null;
    }
    /**
     * Set SearchBookingResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\StructType\SearchBookingResponse $searchBookingResult
     * @return \App|C\StructType\SearchBookingResponse
     */
    public function setSearchBookingResult(\App|C\StructType\SearchBookingResponse $searchBookingResult = null)
    {
        if (is_null($searchBookingResult) || (is_array($searchBookingResult) && empty($searchBookingResult))) {
            unset($this->SearchBookingResult);
        } else {
            $this->SearchBookingResult = $searchBookingResult;
        }
        return $this;
    }
    /**
     * Get BookingSummaries value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\ArrayType\ArrayOfBookingSummary|null
     */
    public function getBookingSummaries()
    {
        return isset($this->BookingSummaries) ? $this->BookingSummaries : null;
    }
    /**
     * Set BookingSummaries value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\ArrayType\ArrayOfBookingSummary $bookingSummaries
     * @return \App|C\StructType\SearchBookingResponse
     */
    public function setBookingSummaries(\App|C\ArrayType\ArrayOfBookingSummary $bookingSummaries = null)
    {
        if (is_null($bookingSummaries) || (is_array($bookingSummaries) && empty($bookingSummaries))) {
            unset($this->BookingSummaries);
        } else {
            $this->BookingSummaries = $bookingSummaries;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \App|C\StructType\SearchBookingResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
