<?php

namespace App|C\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Seat StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:Seat
 * @subpackage Structs
 */
class Seat extends ApiObject
{
    /**
     * The AssociatedAncillaryCode
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $AssociatedAncillaryCode;
    /**
     * The IsAvailable
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $IsAvailable;
    /**
     * The Letter
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Letter;
    /**
     * The RefPassenger
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $RefPassenger;
    /**
     * The SeatTypeCode
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $SeatTypeCode;
    /**
     * Constructor method for Seat
     * @uses Seat::setAssociatedAncillaryCode()
     * @uses Seat::setIsAvailable()
     * @uses Seat::setLetter()
     * @uses Seat::setRefPassenger()
     * @uses Seat::setSeatTypeCode()
     * @param string $associatedAncillaryCode
     * @param bool $isAvailable
     * @param string $letter
     * @param string $refPassenger
     * @param string $seatTypeCode
     */
    public function __construct($associatedAncillaryCode = null, $isAvailable = null, $letter = null, $refPassenger = null, $seatTypeCode = null)
    {
        $this
            ->setAssociatedAncillaryCode($associatedAncillaryCode)
            ->setIsAvailable($isAvailable)
            ->setLetter($letter)
            ->setRefPassenger($refPassenger)
            ->setSeatTypeCode($seatTypeCode);
    }
    /**
     * Get AssociatedAncillaryCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getAssociatedAncillaryCode()
    {
        return isset($this->AssociatedAncillaryCode) ? $this->AssociatedAncillaryCode : null;
    }
    /**
     * Set AssociatedAncillaryCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $associatedAncillaryCode
     * @return \App|C\StructType\Seat
     */
    public function setAssociatedAncillaryCode($associatedAncillaryCode = null)
    {
        // validation for constraint: string
        if (!is_null($associatedAncillaryCode) && !is_string($associatedAncillaryCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($associatedAncillaryCode, true), gettype($associatedAncillaryCode)), __LINE__);
        }
        if (is_null($associatedAncillaryCode) || (is_array($associatedAncillaryCode) && empty($associatedAncillaryCode))) {
            unset($this->AssociatedAncillaryCode);
        } else {
            $this->AssociatedAncillaryCode = $associatedAncillaryCode;
        }
        return $this;
    }
    /**
     * Get IsAvailable value
     * @return bool|null
     */
    public function getIsAvailable()
    {
        return $this->IsAvailable;
    }
    /**
     * Set IsAvailable value
     * @param bool $isAvailable
     * @return \App|C\StructType\Seat
     */
    public function setIsAvailable($isAvailable = null)
    {
        // validation for constraint: boolean
        if (!is_null($isAvailable) && !is_bool($isAvailable)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($isAvailable, true), gettype($isAvailable)), __LINE__);
        }
        $this->IsAvailable = $isAvailable;
        return $this;
    }
    /**
     * Get Letter value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getLetter()
    {
        return isset($this->Letter) ? $this->Letter : null;
    }
    /**
     * Set Letter value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $letter
     * @return \App|C\StructType\Seat
     */
    public function setLetter($letter = null)
    {
        // validation for constraint: string
        if (!is_null($letter) && !is_string($letter)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($letter, true), gettype($letter)), __LINE__);
        }
        if (is_null($letter) || (is_array($letter) && empty($letter))) {
            unset($this->Letter);
        } else {
            $this->Letter = $letter;
        }
        return $this;
    }
    /**
     * Get RefPassenger value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getRefPassenger()
    {
        return isset($this->RefPassenger) ? $this->RefPassenger : null;
    }
    /**
     * Set RefPassenger value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $refPassenger
     * @return \App|C\StructType\Seat
     */
    public function setRefPassenger($refPassenger = null)
    {
        // validation for constraint: string
        if (!is_null($refPassenger) && !is_string($refPassenger)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($refPassenger, true), gettype($refPassenger)), __LINE__);
        }
        if (is_null($refPassenger) || (is_array($refPassenger) && empty($refPassenger))) {
            unset($this->RefPassenger);
        } else {
            $this->RefPassenger = $refPassenger;
        }
        return $this;
    }
    /**
     * Get SeatTypeCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSeatTypeCode()
    {
        return isset($this->SeatTypeCode) ? $this->SeatTypeCode : null;
    }
    /**
     * Set SeatTypeCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $seatTypeCode
     * @return \App|C\StructType\Seat
     */
    public function setSeatTypeCode($seatTypeCode = null)
    {
        // validation for constraint: string
        if (!is_null($seatTypeCode) && !is_string($seatTypeCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($seatTypeCode, true), gettype($seatTypeCode)), __LINE__);
        }
        if (is_null($seatTypeCode) || (is_array($seatTypeCode) && empty($seatTypeCode))) {
            unset($this->SeatTypeCode);
        } else {
            $this->SeatTypeCode = $seatTypeCode;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \App|C\StructType\Seat
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
