<?php

namespace App|C\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SpecialServiceDataDoco StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:SpecialServiceDataDoco
 * @subpackage Structs
 */
class SpecialServiceDataDoco extends ApiObject
{
    /**
     * The ApplicableCountryCode
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ApplicableCountryCode;
    /**
     * The IssuingCountryCode
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $IssuingCountryCode;
    /**
     * The PlaceOfBirth
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $PlaceOfBirth;
    /**
     * The VisaInfantIndicator
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $VisaInfantIndicator;
    /**
     * The VisaIssuanceDate
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $VisaIssuanceDate;
    /**
     * The VisaNumber
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $VisaNumber;
    /**
     * The VisaTypeCode
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $VisaTypeCode;
    /**
     * Constructor method for SpecialServiceDataDoco
     * @uses SpecialServiceDataDoco::setApplicableCountryCode()
     * @uses SpecialServiceDataDoco::setIssuingCountryCode()
     * @uses SpecialServiceDataDoco::setPlaceOfBirth()
     * @uses SpecialServiceDataDoco::setVisaInfantIndicator()
     * @uses SpecialServiceDataDoco::setVisaIssuanceDate()
     * @uses SpecialServiceDataDoco::setVisaNumber()
     * @uses SpecialServiceDataDoco::setVisaTypeCode()
     * @param string $applicableCountryCode
     * @param string $issuingCountryCode
     * @param string $placeOfBirth
     * @param bool $visaInfantIndicator
     * @param string $visaIssuanceDate
     * @param string $visaNumber
     * @param string $visaTypeCode
     */
    public function __construct($applicableCountryCode = null, $issuingCountryCode = null, $placeOfBirth = null, $visaInfantIndicator = null, $visaIssuanceDate = null, $visaNumber = null, $visaTypeCode = null)
    {
        $this
            ->setApplicableCountryCode($applicableCountryCode)
            ->setIssuingCountryCode($issuingCountryCode)
            ->setPlaceOfBirth($placeOfBirth)
            ->setVisaInfantIndicator($visaInfantIndicator)
            ->setVisaIssuanceDate($visaIssuanceDate)
            ->setVisaNumber($visaNumber)
            ->setVisaTypeCode($visaTypeCode);
    }
    /**
     * Get ApplicableCountryCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getApplicableCountryCode()
    {
        return isset($this->ApplicableCountryCode) ? $this->ApplicableCountryCode : null;
    }
    /**
     * Set ApplicableCountryCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $applicableCountryCode
     * @return \App|C\StructType\SpecialServiceDataDoco
     */
    public function setApplicableCountryCode($applicableCountryCode = null)
    {
        // validation for constraint: string
        if (!is_null($applicableCountryCode) && !is_string($applicableCountryCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($applicableCountryCode, true), gettype($applicableCountryCode)), __LINE__);
        }
        if (is_null($applicableCountryCode) || (is_array($applicableCountryCode) && empty($applicableCountryCode))) {
            unset($this->ApplicableCountryCode);
        } else {
            $this->ApplicableCountryCode = $applicableCountryCode;
        }
        return $this;
    }
    /**
     * Get IssuingCountryCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getIssuingCountryCode()
    {
        return isset($this->IssuingCountryCode) ? $this->IssuingCountryCode : null;
    }
    /**
     * Set IssuingCountryCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $issuingCountryCode
     * @return \App|C\StructType\SpecialServiceDataDoco
     */
    public function setIssuingCountryCode($issuingCountryCode = null)
    {
        // validation for constraint: string
        if (!is_null($issuingCountryCode) && !is_string($issuingCountryCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($issuingCountryCode, true), gettype($issuingCountryCode)), __LINE__);
        }
        if (is_null($issuingCountryCode) || (is_array($issuingCountryCode) && empty($issuingCountryCode))) {
            unset($this->IssuingCountryCode);
        } else {
            $this->IssuingCountryCode = $issuingCountryCode;
        }
        return $this;
    }
    /**
     * Get PlaceOfBirth value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPlaceOfBirth()
    {
        return isset($this->PlaceOfBirth) ? $this->PlaceOfBirth : null;
    }
    /**
     * Set PlaceOfBirth value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $placeOfBirth
     * @return \App|C\StructType\SpecialServiceDataDoco
     */
    public function setPlaceOfBirth($placeOfBirth = null)
    {
        // validation for constraint: string
        if (!is_null($placeOfBirth) && !is_string($placeOfBirth)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($placeOfBirth, true), gettype($placeOfBirth)), __LINE__);
        }
        if (is_null($placeOfBirth) || (is_array($placeOfBirth) && empty($placeOfBirth))) {
            unset($this->PlaceOfBirth);
        } else {
            $this->PlaceOfBirth = $placeOfBirth;
        }
        return $this;
    }
    /**
     * Get VisaInfantIndicator value
     * @return bool|null
     */
    public function getVisaInfantIndicator()
    {
        return $this->VisaInfantIndicator;
    }
    /**
     * Set VisaInfantIndicator value
     * @param bool $visaInfantIndicator
     * @return \App|C\StructType\SpecialServiceDataDoco
     */
    public function setVisaInfantIndicator($visaInfantIndicator = null)
    {
        // validation for constraint: boolean
        if (!is_null($visaInfantIndicator) && !is_bool($visaInfantIndicator)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($visaInfantIndicator, true), gettype($visaInfantIndicator)), __LINE__);
        }
        $this->VisaInfantIndicator = $visaInfantIndicator;
        return $this;
    }
    /**
     * Get VisaIssuanceDate value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getVisaIssuanceDate()
    {
        return isset($this->VisaIssuanceDate) ? $this->VisaIssuanceDate : null;
    }
    /**
     * Set VisaIssuanceDate value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $visaIssuanceDate
     * @return \App|C\StructType\SpecialServiceDataDoco
     */
    public function setVisaIssuanceDate($visaIssuanceDate = null)
    {
        // validation for constraint: string
        if (!is_null($visaIssuanceDate) && !is_string($visaIssuanceDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($visaIssuanceDate, true), gettype($visaIssuanceDate)), __LINE__);
        }
        if (is_null($visaIssuanceDate) || (is_array($visaIssuanceDate) && empty($visaIssuanceDate))) {
            unset($this->VisaIssuanceDate);
        } else {
            $this->VisaIssuanceDate = $visaIssuanceDate;
        }
        return $this;
    }
    /**
     * Get VisaNumber value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getVisaNumber()
    {
        return isset($this->VisaNumber) ? $this->VisaNumber : null;
    }
    /**
     * Set VisaNumber value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $visaNumber
     * @return \App|C\StructType\SpecialServiceDataDoco
     */
    public function setVisaNumber($visaNumber = null)
    {
        // validation for constraint: string
        if (!is_null($visaNumber) && !is_string($visaNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($visaNumber, true), gettype($visaNumber)), __LINE__);
        }
        if (is_null($visaNumber) || (is_array($visaNumber) && empty($visaNumber))) {
            unset($this->VisaNumber);
        } else {
            $this->VisaNumber = $visaNumber;
        }
        return $this;
    }
    /**
     * Get VisaTypeCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getVisaTypeCode()
    {
        return isset($this->VisaTypeCode) ? $this->VisaTypeCode : null;
    }
    /**
     * Set VisaTypeCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $visaTypeCode
     * @return \App|C\StructType\SpecialServiceDataDoco
     */
    public function setVisaTypeCode($visaTypeCode = null)
    {
        // validation for constraint: string
        if (!is_null($visaTypeCode) && !is_string($visaTypeCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($visaTypeCode, true), gettype($visaTypeCode)), __LINE__);
        }
        if (is_null($visaTypeCode) || (is_array($visaTypeCode) && empty($visaTypeCode))) {
            unset($this->VisaTypeCode);
        } else {
            $this->VisaTypeCode = $visaTypeCode;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \App|C\StructType\SpecialServiceDataDoco
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
